//=============================================================================
// Copyright  2010 Point Grey Research, Inc. All Rights Reserved.
//
// This software is the confidential and proprietary information of Point
// Grey Research, Inc. ("Confidential Information").  You shall not
// disclose such Confidential Information and shall use it only in
// accordance with the terms of the license agreement you entered into
// with PGR.
//
// PGR MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
// SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
// PURPOSE, OR NON-INFRINGEMENT. PGR SHALL NOT BE LIABLE FOR ANY DAMAGES
// SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
// THIS SOFTWARE OR ITS DERIVATIVES.
//=============================================================================
//=============================================================================
// $Id: GigEGrabEx.cpp,v 1.10 2010-06-01 18:19:44 soowei Exp $
// $Id: GigECameraCap.h, v 1.10 2013-06-11 21:23:00 yoshi Exp $
//=============================================================================

// Respect: http://taishoh-lab.net/blog/?p=35

#ifndef __GIGE_CAMERA_CAP_H__
#define __GIGE_CAMERA_CAP_H__

#include "FlyCapture2.h"
#include "opencv2\\opencv.hpp"

void PrintBuildInfo();
void PrintCameraInfo( FlyCapture2::CameraInfo* pCamInfo );
void PrintStreamChannelInfo( FlyCapture2::GigEStreamChannel* pStreamChannel );
void PrintError( FlyCapture2::Error error );

class GigEBusManager
{
public:
	GigEBusManager();
	~GigEBusManager();

	int Init();
	unsigned int num_cameras();
	FlyCapture2::PGRGuid* guid(unsigned int id);

private:
	FlyCapture2::Error error;
	FlyCapture2::BusManager busMgr;
	FlyCapture2::CameraInfo camInfo[10];
	unsigned int numCamInfo;
	unsigned int numCameras;
	FlyCapture2::PGRGuid* _guid;
	FlyCapture2::InterfaceType* _interfaceType;
};

class GigECameraCap
{
public:
	GigECameraCap();
	~GigECameraCap();

	int Init(FlyCapture2::PGRGuid* guid);
	int Capture();

public:
	int grap(cv::Mat &img);
	IplImage* iplgrap();

protected:
	FlyCapture2::PGRGuid* _guid;
	FlyCapture2::Error error;
	FlyCapture2::GigECamera cam;
	FlyCapture2::CameraInfo camInfo;
	unsigned int numStreamChannels;
	FlyCapture2::GigEImageSettingsInfo imageSettingsInfo;
	FlyCapture2::GigEImageSettings imageSettings;
	FlyCapture2::Image rawImage;  
    FlyCapture2::Image convertedImage;

private:
	int imageCnt;
	IplImage *cvImage;
	cv::Mat mat;
};

#endif __GIGE_CAMERA_CAP_H__
